(define (silk-benchmark)
  (define (print x) (write x) (newline) x)
  (define (f n) (if (= n 0) f (f (- n 1))))
  (define (foo n) (print (time (f n) 1)))
  (define n 100000)
  (print (System.getProperties))
  (begin
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    )
  )

(define (guile-benchmark)
  (define (print x) (write x) (newline) x)
  (define (time-of-day)
    (let ((it (gettimeofday)))
      (+ (exact->inexact (car it)) (* (cdr it) 1.0e-6))))
  (define (time thunk)
    (let ((start (time-of-day)))
      (thunk)
      (- (time-of-day) start)))
  (define (f n) (if (= n 0) f (f (- n 1))))
  (define (foo n) (print (time (lambda () (f n)))))
  (define n 100000)
  (begin
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    (foo n)
    )
  )
