(define (dx x N)
  ;; N ~ x*x + dx*2*x
  ;; dx = (N - x*x)/(2*x)

  ;; Use x = N/2:
  ;; x = N/2 + (N - N^2/4)/N
  ;; x = (N^2/2 + N -N^2/4)/N
  ;; x = (N^2/4 + N)/N
  ;; x = N/4 + 1

  ;; Use x = N;
  ;; x = N + (N - N^2)/(2*N)
  ;; x = (2N^2 + N - N^2)/(2*N)
  ;; x = (N^2 + N)/(2*N)
  ;; x = (N + 1)/2
   (/ (- N (* x x)) (* 2.0 x)))

(define (update x N) (+ x (dx x N)))

(define x 1.0)

(define x (+ x (dx x 10.0)))

(define (my-sqrt N)
  (let loop ((old (/ N 2.0)))
    (let ((dx (dx old N)))
      (if (< (abs dx) 1.0e-15) (+ old dx)
	  (loop (+ old dx))))))