(define (find-field class name)
  (find (lambda (f) (.equals (.getName f) name)) ; Memoizable.
	(all-fields class)))

(define (field object name)
  (.get (find-field (.getClass object) (.toString name)) object))

(define (field-set! object name value)
  (.set (find-field (.getClass object) (.toString name)) object value))

(define (static-field class name)
  (.get (find-field class (.toString name)) class))

(define (static-field-set! class name value)
  (.set (find-field class (.toString name)) class value))
