// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * Special ... pattern variable
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class DotDotDotFragment extends PatternVariableFragment {
    IdentifierFragment variableName = null;
    private void init (String name, Token t) {
	// TODO: do the right exception handling here
	token = t;
	this.name = new IdentifierFragment(name, t);
	try {
	    constraint = MacroExpander.lookupConstraint("*");
	} catch (Exception e) { }
	variableName
	    = new IdentifierFragment
		(IdentifierFragment.uniquePrefix + "dotdotdot", t);
    }
    public DotDotDotFragment () {
	init("...", makeToken(JavaTokenTypes.DOTDOTDOT, "..."));
    }
    public DotDotDotFragment (Token t) {
	init("...", t); 
    }
    public IdentifierFragment getVariableName() { return variableName; }
    void pprint(PrettyStream p, int depth, boolean isCode) { 
	if (isCode)
	    getVariableName().pprint(p, depth, isCode);
	else
	    p.print(name); 
    }
}

