(define (doc)
  (define (macro? s)
    (eq? (.getClass (.getGlobalValue s)) silk.Macro.class))
  (define (display-macro s)
    (display "syntax ")
    (display s)
    (display ":")
    (display (.getGlobalValue s))
    (newline))
  (define (display-symbol s)
    (if (and (.isDefined s)
	     (procedure? (.getGlobalValue s)))
	(if (macro? s)
	    (display-macro s)
	    (begin (display (.getGlobalValue s))
		   (newline)))))
  (define (iter xs f p)
    (if (.hasNext xs)
	(let ((it (.nextElement xs)))
	  (if (p it) (f it))
	  (iter xs f p))))
  (let ((symbols (.elements Symbol.symbolTable$)))
    (iter symbols display-symbol .isDefined)))