"
Date: Sun, 3 Feb 2002 12:48:32 -0800
Mime-Version: 1.0 (Apple Message framework v480)
Content-Type: text/plain; charset=US-ASCII; format=flowed
Subject: JScheme:  Infinite precision math?
From: beard@netscape.com (Patrick Beard)
To: kanderso@bbn.com
Content-Transfer-Encoding: 7bit
Message-Id: <628B7EB4-18E7-11D6-AF09-00039310A47A@netscape.com>
X-Mailer: Apple Mail (2.480)
X-UIDL: d7b510b497eb2f16b717280b2b19ae27

Is it implemented? How do I get it? If I type in:

(define (fact n)
    (if (> n 1)
        (* n (fact (- n 1)))
        1))

and then

(fact 20)
-2102132736

In other Scheme's I've used this and I get the expected result...

- Patrick
"

(define (fact n)
    (if (> n 1)
        (* n (fact (- n 1)))
        1))

(import "java.math.BigInteger")
(define (Big x)
  (if (instanceof x BigInteger.class) x
      (BigInteger. (.toString x))))

(define (bigify2 f)
  (lambda (a b) (f (Big a) (Big b))))

(define b> (bigify2 (lambda (a b) (> (.subtract a b) 0))))

(define b* (bigify2 (lambda (a b) (.multiply a b))))
(define b- (bigify2 (lambda (a b) (.subtract a b))))

(define (bfact n)
    (if (b> n 1)
        (b* n (bfact (b- n 1)))
        1))