(define (bornon)
  ;; This is an approximation based on the average year.
  (let* ((d0 (Date. "8/2/1982"))
	 (d1 (Date.))
	 (year (- (.getYear d1) 83))
	 (month (+ (.getMonth d1) 4))
	 (day (+ (.getDate d1) -1)))
    (list year month day)))

(define (bornon)
  ;; This is more accurate but can give negative days early in the month.
  (let* ((d0 (Date. "8/2/1982"))
	 (d1 (Date.))
	 (days (Math.floor (/ (- (.getTime d1) (.getTime d0)) 86400000.0)))
	 (days/year 365.2425)
	 (years (Math.floor (/ days days/year)))
	 (days/month (/ days/year 12))
	 (months (Math.floor (/ (- days (* years days/year)) days/month)))
	 (days2 (Math.floor (- days (+ (* years days/year) (* months days/month))))))
    (map Math.round (list years months days2))))

(let ((bod (bornon)))
  (display
   (string-append
    "You have worked at BBN for "
    (car bod) " years "
    (cadr bod) " months and "
    (caddr bod) " days.\n")))
