// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * Character literal fragment
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class CharacterFragment extends LiteralFragment {
    public CharacterFragment(Character x) { 
	super(makeToken(JavaTokenTypes.CHAR_LITERAL, x.toString()));
    }   
    public CharacterFragment(Token t) { 
	super(t);
    }   
    public Object getValue() { 
	return new Character(getText().charAt(1));
    }
    // TODO: COMPILETEMPLATE???
}

